/* PigLatin.java is an English-to-Pig-Latin translator. * * Written by: Charles Hoot, June 2000. * Written for: GUI Interlude 2 in "Hands On Java". * Modified from code written by: *		Joel C. Adams, Spring 1994 for "Hands On C++". * * Input: An English sentence. * Precondition: The sentence contains at least one word. * Output: The equivalent Pig-latin sentence. **********************************************************/import ann.easyio.*;import java.util.StringTokenizer;class PigLatin extends Object{  static Screen theScreen = new Screen();  static Keyboard theKeyboard = new Keyboard();  public static void main(String args[])  {  String englishWord,         piglatinWord;  theScreen.print("\nTo translate a sentence from English to Pig-latin,\nenter a sentence: ");  String line = theKeyboard.readLine();   StringTokenizer parser = new StringTokenizer(line, " \n\t", true);  int numberTokens = parser.countTokens();  for(int i= 0; i <  numberTokens; i++)  {      englishWord = parser.nextToken();      piglatinWord = toPiglatin(englishWord);      theScreen.print(piglatinWord);  }  theScreen.println("\nTranslation completed!");}/********************************************************* * toPiglatin translates a word from English to Pig-latin. * Receive: englishWord, a string. * Return: piglatinWord, a string. * * Precondition: * 		aWord is a non-empty string that does not contain any whitespace * Post Condition: *		pig latin equivalent is returned *********************************************************/ public static String toPiglatin(String aWord) { 	//We want to break the word up into two pieces 	//    firstPart -- lastPart 	//    Delimiters are "aeiouyAEIOUY"  (vowel marks the break) 	//    We do want to know what the delimeter was - return as a token 	StringTokenizer parser = new StringTokenizer(aWord, "aeiouyAEIOUY", true); 	String firstPart = parser.nextToken(); 	//Check to see if we had a vowel as the initial character 	if(isVowel(firstPart)) 	{ 		return aWord + "yay"; 	} 	//Check to see if we only had one token (no vowels) 	if(parser.countTokens() == 0) 	{ 		return aWord; 	} 	//Special cases have been taken care of, lets do the 	//standard stuff now 	//get everything after the first part 	String lastPart = aWord.substring(firstPart.length()); 	return lastPart + firstPart + "ay"; }/********************************************************* * isVowel determines if a string contains a single vowel. * Receive: aPiece, a string. * Return: boolean * * Precondition: * 		aPiece is a string that does not contain any whitespace *********************************************************/ public static boolean isVowel(String aPiece) { 	//Check to see if this a vowel (not y) 	if(aPiece.length() != 1) 		return false; 	String checkString = "aeiouAEIOU"; 	//See if we can find the single character in our check string 	//If index gives back -1 => not a vowel 	return !(checkString.indexOf(aPiece) == -1); }}